#!/usr/bin/env python
# -*- coding: utf_8 -*-

from application.app import db, ma
from .base import PrimaryModel 
from marshmallow import Schema, fields, INCLUDE, EXCLUDE

class MenuModel(PrimaryModel):
    __tablename__ = 'evm_menu'

    name = db.Column(db.String(100), nullable = True)
    parentId = db.Column(db.String(100), nullable = True)
    path = db.Column(db.String(100), nullable = True)
    disabled = db.Column(db.Boolean, nullable = True, default = False)
    fixed = db.Column(db.Boolean, nullable = False, default = False)
    hasChildren = db.Column(db.Boolean, nullable = True, default = False)
    icon = db.Column(db.String(100), nullable = True, default = '')

    # __table_args__ = (
    #     db.Index('idx_xxx', 'xxx', mysql_using='btree'),
    # )

    def __init__(self, name, parentId, path, disabled=False, fixed=False, hasChildren=False, icon=''):
        self.name = name
        self.parentId = parentId
        self.path = path
        self.disabled = disabled
        self.fixed = fixed
        self.hasChildren = hasChildren
        self.icon = icon

    def __repr__(self):
        return '<MenuModel %r>' % (self.name)

    def to_dict(self):
        return {
            'name': self.name,
            'parentId': self.parentId,
            'path': self.path,
            'disabled': self.disabled,
            'fixed': self.fixed,
            'hasChildren': self.hasChildren,
            'icon': self.icon,
        }
